#include<stdio.h>
#include<iostream>
#include<sstream>
#include "Riostream.h"
#include<TH1.h>
#include<TH2F.h>
#include<TCanvas.h>
#include<math.h>
#include<TGraph.h>
#include<TFile.h>
#include<TKey.h>
#include<TObjString.h>
#include<TGraphErrors.h>
#include<TVectorD.h>
#include<TString.h>
#include<iostream>
#include<TStyle.h>
#include<TLegend.h>
#include<TColor.h>
#include<TMath.h>
#include<TROOT.h>
#include "TMatrixDSymEigen.h"
#include "TDecompSVD.h"
#include "utils.h"
#include "AtlasStyle.C"
#include "AtlasLabels.C"
#include "SlidingBinsSmoothing.h"

   // checks if file with name "fin" is already open, and if not opens one
   TFile* OpenFile( const TString& fin )
   {
      TFile* file = gDirectory->GetFile();
      if (file==0 || fin != file->GetName()) {
         if (file != 0) {
            gROOT->cd();
            file->Close();
         }
         cout << "--- Opening root file \"" << fin << "\" in read mode" << endl;
         file = TFile::Open( fin, "READ" );
      }
      else {
         file = gDirectory->GetFile();
      }

      file->cd();
      return file;
   }

   // return list of keys for any inheritant
   UInt_t GetListOfKeys( TDirectory *rfdir, TString inherits, TList& keyList )
   {

      // get a list of "inherits" found in directory
      UInt_t ni = 0;
      if (rfdir==0 ) return 0;

      cout << rfdir << endl;

      TList* keys = rfdir->GetListOfKeys();
      if (keys == 0) {
         cout << "Directory \"" << rfdir->GetName() << "\" contains no keys" << endl;
         return 0;
      }

      keyList.Clear();
      keyList.SetOwner( kFALSE );

      TIter rfnext(rfdir->GetListOfKeys());
      TKey *rfkey;
      while ((rfkey = (TKey*)rfnext())) {
         // make sure, that we only look at graphs
         TClass *cl = gROOT->GetClass(rfkey->GetClassName());
         if (cl->InheritsFrom( inherits )) {
            keyList.Add(rfkey);
            ni++;
         }
         else {
//             cout << "*** Problem in  <GetListOfKeys>: Key \"" << rfkey->GetClassName()
//                  << "\" does not inherint from: \"" << inherits << "\" ==> ignore it" << endl;
         }
      }
      cout << "--- Found " << ni << " \"" << inherits << "\" keys in directory \"" <<  rfdir->GetName() << "\"" << endl;

      return ni;
   }

   // set marker and color of graph according to its name (experiment)
   Bool_t SetGraphStyle( TGraph* graph )
   {
      // settings
      UInt_t  n = 6;
      Float_t scale = 1.2;
      Float_t sze = 0.6*scale;

      TString exp[] = {"gamma-jet", "Zjet", "MJB", "MPF", "track-jet", "ComplexMergerFromRebinnedMassSpectrum" };
      UInt_t  col[] = {221, 100, 107, 103, 118, 1 };
      UInt_t  mrk[] = {22, 25, 26, 21, 23, 22 };

      // specific setings
      TString name = graph->GetName();
      Bool_t  found = kFALSE;
      for (UInt_t i=0; i<n; i++) {
         if (name.Contains( exp[i] )) {
            graph->SetMarkerColor( col[i] ); 
            graph->SetLineColor  ( col[i] );
            graph->SetMarkerStyle( mrk[i] ); 
            Float_t s = sze*(mrk[i]==20 || mrk[i]==21 || mrk[i]==27 || mrk[i]==30 ? 1.2 : mrk[i]==22 ? 1.4 : 1.0);
            graph->SetMarkerSize ( s  );
            found = kTRUE;
            break;
         }
      }
      return found;      
   }


void SetFrameStyle( TH2F* frame_, Int_t drawFrame = 1, Float_t scale_ = 1.0, Float_t labelSize_ = 0.055 ){
   labelSize_ *= scale_;
   if(drawFrame){ frame_->Draw(); }
   frame_->SetLabelOffset( 0.008, "X" );// label offset on x axis
   frame_->SetLabelOffset( 0.008, "Y" );// label offset on x axis
   frame_->GetXaxis()->SetTitleOffset( 1.26 );
   frame_->GetYaxis()->SetTitleOffset( 1.25 );
   frame_->GetXaxis()->SetTitleSize( 0.055*scale_ );
   frame_->GetYaxis()->SetTitleSize( 0.055*scale_ );
   frame_->GetXaxis()->SetLabelSize( labelSize_ );
   frame_->GetYaxis()->SetLabelSize( labelSize_ );
}

void SetFrameStyle( TH1D* frame_, Int_t drawFrame = 1, Float_t scale_ = 1.0, Float_t labelSize_ = 0.055 ){
   labelSize_ *= scale_;
   if(drawFrame){ frame_->Draw(); }
   frame_->SetLabelOffset( 0.008, "X" );// label offset on x axis
   frame_->SetLabelOffset( 0.008, "Y" );// label offset on x axis
   frame_->GetXaxis()->SetTitleOffset( 1.26 );
   frame_->GetYaxis()->SetTitleOffset( 1.25 );
   frame_->GetXaxis()->SetTitleSize( 0.055*scale_ );
   frame_->GetYaxis()->SetTitleSize( 0.055*scale_ );
   frame_->GetXaxis()->SetLabelSize( labelSize_ );
   frame_->GetYaxis()->SetLabelSize( labelSize_ );
}

void SetCanvasStyle( TCanvas *can_, Float_t scale_ = 1.0 ){
  can_->cd();
  can_->SetTicks();
  can_->SetLeftMargin  ( 0.140*scale_ );
  can_->SetRightMargin ( 0.025*scale_ );
  can_->SetBottomMargin( 0.150*scale_  );
  can_->SetTopMargin( 0.015*scale_ );
}

void SetCanvasStyle2D( TCanvas *can_, Float_t scale_ = 1.0 ){
  can_->cd();
  can_->SetLogx();
  can_->SetLogy();
  can_->SetRightMargin ( 0.16*scale_ );
}

void PlotLabelEnergyLumi( Double_t x, Double_t y ){
   ATLASLabel( x, y,1,kBlack);
   myText( x, y-0.06,kBlack,"#sqrt{s} = 7 TeV",0.05);
   myText( x, y-0.12+0.005,kBlack,"#int",0.03);
   myText( x, y-0.12,kBlack,"  L dt = -- fb^{-1}",0.05);

}

TMatrixD* ComputeCorrelation( TMatrixD *covMat, Int_t N_ ){ 

   TMatrixD *corrMat = new TMatrixD( *covMat ); 
   for( Int_t i=0; i<N_; i++ ){ 
      for( Int_t j=0; j<N_; j++ ){ 
         if( (*covMat)[i][i]!=0. && (*covMat)[j][j]!=0. )
            (*corrMat)[i][j] = (*covMat)[i][j] / sqrt( (*covMat)[i][i] * (*covMat)[j][j] ); 
      } 
   } 
   return corrMat; 
}

void SaveNPtoFile( Int_t N, TH1D *EigenVecH, TString *fileName ){
   FILE* fNP = fopen( (*fileName), "w" );
   if( !fNP ){
      cout << "Could not open file: " << (*fileName) << endl;
      exit(1);
   }
   for( Int_t i=0; i<N; i++ ){
      fprintf( fNP, "%lf  %lf  %lf \n", EigenVecH->GetBinCenter(i+1)-EigenVecH->GetBinWidth(i+1)/2., EigenVecH->GetBinCenter(i+1)+EigenVecH->GetBinWidth(i+1)/2., EigenVecH->GetBinContent(i+1) );
   }
   fclose( fNP );
}

void Compute_desMatrices_covMat( TMatrixD* &d, TVectorD* &eigenVal, TMatrixD* &s, const TMatrixD &covMat ){
   Int_t i, j;
   const Int_t N = covMat.GetNrows();

   // compute eigenvectors
   TMatrixDSym* symMat = new TMatrixDSym( N );
   for ( i=0; i<N; i++) {
      for ( j=0; j<N; j++) {
         (*symMat)(i,j) = covMat(i,j);
      }
   }
   if( !symMat->IsSymmetric() ){
      cout << "Problem: cov matrix is not symmetric!!!" << endl;
      exit(1);
   }
   TMatrixDSymEigen* eigen = new TMatrixDSymEigen( *symMat );

   // D = ST C S
   TMatrixD *_SiRoot = new TMatrixD( eigen->GetEigenVectors() );
   eigenVal = new TVectorD( eigen->GetEigenValues() );
   TMatrixD *_SRoot  = new TMatrixD( *_SiRoot ); // copy
   _SiRoot->Transpose( *_SiRoot ); // invert (= transpose for unitary matrices)
   
   // diagonal matrices
   TMatrixD *_DRoot = new TMatrixD( N, N );
   _DRoot->Mult( (*_SiRoot), (*symMat) ); (*_DRoot) *= (*_SRoot);
   delete symMat;
   
   // sanity check: matrix must be diagonal and positive definit
   Double_t epsilon = 3.0e-6;
   for ( i=0; i<N; i++) {
      //       cout << i << " " << (*_DRoot)(i,i) << " " << (*eigenVal)[i] << endl;
      for ( j=0; j<N; j++) {
         if ((i != j && TMath::Abs((*_DRoot)(i,j)) > epsilon)
             ||
             (i == j && ((*_DRoot)(i,i) < 0 || fabs((*_DRoot)(i,i)-(*eigenVal)[i]) > 3.e-6 ) && (fabs((*_DRoot)(i,i)) > 1.e-15) )
             ) {
            cout << i << " " << j << " " << (*_DRoot)(i,i) << " " << (*eigenVal)[i] << " " << (*_SRoot)(i,j) << " " << (*_SRoot)(j,i) << " " << (*_DRoot)(i,j) << " " <<  TMath::Abs((*_DRoot)(i,j))/TMath::Sqrt((*_DRoot)(i,i)*(*_DRoot)(j,j)) << " " << (*_DRoot)(j,j) << " < GetDiagonalMatrix > error(2) in matrix diagonalisation " << (*_DRoot)(i,i)-(*eigenVal)[i] << endl;
            exit(1);
         }
      }
   }
   
   //choose the matrix that will be used later for fluctuations
   d = new TMatrixD( *_DRoot );
   s = new TMatrixD( *_SRoot );
}


void PlotNuisanceParametersFit( Int_t usedEigenVectors  = 4, TString EM_LC_  = "EM" , TString R_  = "4", Int_t linearSumEscales = 1, Float_t Emin = 15., Float_t Emax = 1900. ){

   Int_t plotCorrelations = 1;

   TString EM_LCW_;
   if( EM_LC_.Contains("LC") ){
      EM_LCW_ = EM_LC_ + "W";
   }
   else{
      EM_LCW_ = EM_LC_;
   }

   TString channelName = EM_LCW_ + "JES_R" + R_ + "_points";

   stringstream s_ReducedNP;
   s_ReducedNP << "ReducedNP";
   if( usedEigenVectors < 9 ){ s_ReducedNP << 0; }
   s_ReducedNP << (usedEigenVectors + 1);
   s_ReducedNP << "/";
   TString ReducedNP_s;
   s_ReducedNP >> ReducedNP_s;

   TString fin = "/exp/babar/malaescu/HVPTools/exe/ResultsCombined_JES/Results_2011/testapp_" + EM_LCW_ + "JES_R" + R_ + "_Zjet-MPF-MJB_NuisanceParam_TSpline2_10000toys_NoSplineExt_BinsAndPoints_MaxSystNoShift_WeightsNoCorrel.root";
   TString filesLocationS = "Results_" + EM_LCW_ + "JES_R" + R_ + "_ZJ-MPF-MJB_TSpline2_10000toys_NoSplineExt_NuisanceParam_fit/";

   /*
   TString fin = "/exp/babar/malaescu/HVPTools/exe/ResultsCombined_JES/Results_2011/testapp_" + EM_LCW_ + "JES_R" + R_ + "_Zjet-MPF_NuisanceParam_TSpline2_10000toys_WithSplineExt_BinsAndPoints_MaxSystNoShift_WeightsNoCorrel.root";
   TString filesLocationS = "Results_" + EM_LCW_ + "JES_R" + R_ + "_ZJ-MPF_TSpline2_10000toys_WithSplineExt_NuisanceParam_BinsAndPoints_WeightsNoCorrel/";
   */

   SetAtlasStyle();
   gStyle->SetOptStat( 0 );
   gStyle->SetPalette( 1 );

   Int_t N= /*1777*/ 1000-17 /*576*/ /* 100 */ , Nf= 55 /*- 18*/ ;
   Double_t rij, r1, r2;
   FILE *f1, *fj;
   cout << " N = " << N << endl; 
   Double_t binLimits[ N +1 ];

   char* NPfileNames[] = {
      /**/
      "JESfitResult_NP_mjbalphacut.txt",
      "JESfitResult_NP_mjbbetacut.txt",
      "JESfitResult_NP_mjbcbjj1.txt",
      "JESfitResult_NP_mjbcbjr.txt",
      "JESfitResult_NP_mjbfragmentationmodeling.txt",
      "JESfitResult_NP_mjbjetptthreshold.txt",
      "JESfitResult_NP_mjbptasymmetrycut.txt",
      "JESfitResult_NP_mjbueisrfsrmodeling.txt",
      "JESfitResult_NP_mjbstat1.txt",
      "JESfitResult_NP_mjbstat2.txt",
      "JESfitResult_NP_mjbstat3.txt",
      "JESfitResult_NP_mjbstat4.txt",
      "JESfitResult_NP_mjbstat5.txt",
      "JESfitResult_NP_mjbstat6.txt",
      "JESfitResult_NP_mjbstat7.txt",
      "JESfitResult_NP_mjbstat8.txt",
      "JESfitResult_NP_mjbstat9.txt",
      "JESfitResult_NP_mjbstat10.txt",
      /**/
      "JESfitResult_NP_photonescale.txt",
      "JESfitResult_NP_purity.txt",
      "JESfitResult_NP_pu.txt",
      "JESfitResult_NP_gammajetgenerator.txt",
      "JESfitResult_NP_gammajetjer.txt",
      "JESfitResult_NP_gammajetoutofcone.txt",
      "JESfitResult_NP_gammajetradiation.txt",
      "JESfitResult_NP_mpfstat1.txt",
      "JESfitResult_NP_mpfstat2.txt",
      "JESfitResult_NP_mpfstat3.txt",
      "JESfitResult_NP_mpfstat4.txt",
      "JESfitResult_NP_mpfstat5.txt",
      "JESfitResult_NP_mpfstat6.txt",
      "JESfitResult_NP_mpfstat7.txt",
      "JESfitResult_NP_mpfstat8.txt",
      "JESfitResult_NP_mpfstat9.txt",
      "JESfitResult_NP_mpfstat10.txt",
      "JESfitResult_NP_mpfstat11.txt",
      "JESfitResult_NP_mpfstat12.txt",
      //      "JESfitResult_NP_mpfstat13.txt", //
      "JESfitResult_NP_zjetelscale.txt",
      "JESfitResult_NP_zjetextrapolation.txt",
      "JESfitResult_NP_zjetjvf.txt",
      "JESfitResult_NP_zjetkterm.txt",
      "JESfitResult_NP_zjetmc.txt",
      "JESfitResult_NP_zjetveto.txt",
      "JESfitResult_NP_zjetwidth.txt",
      "JESfitResult_NP_zjetstat1.txt",
      "JESfitResult_NP_zjetstat2.txt",
      "JESfitResult_NP_zjetstat3.txt",
      "JESfitResult_NP_zjetstat4.txt",
      "JESfitResult_NP_zjetstat5.txt",
      "JESfitResult_NP_zjetstat6.txt",
      "JESfitResult_NP_zjetstat7.txt",
      "JESfitResult_NP_zjetstat8.txt",
      "JESfitResult_NP_zjetstat9.txt",
      "JESfitResult_NP_zjetstat10.txt",
      "JESfitResult_NP_zjetstat11.txt"
};

  TMatrixD *covMatStat_original = new TMatrixD( N, N ), *covMatSyst_original = new TMatrixD( N, N ), *covMatTot_original = new TMatrixD( N, N );
  for( Int_t ib=0; ib<N; ib++ ){
     for( Int_t jb=0; jb<N; jb++ ){
        (*covMatStat_original)[ib][jb] = 0.; (*covMatSyst_original)[ib][jb] = 0.; (*covMatTot_original)[ib][jb] = 0.;
     }
  }

   // read correction and bin limits
   TVectorD *sf_ = new TVectorD(N);
   FILE *fSF = fopen(filesLocationS+"JESfitResult.txt","r");
   if( !fSF ){
      cout << "Could not open file: " << "JESfitResult.txt" << endl;
      exit(1);
   }
   for( Int_t i=0; i<N; i++ ){
      fscanf(fSF,"%lf",&r1);
      fscanf(fSF,"%lf",&r2);
      binLimits[i] = r1;
      fscanf(fSF,"%lf",&rij);
      ( *sf_ )[i] = rij;
   }
   binLimits[N] = r2;
   fclose( fSF );
   TH1D *sfH = new TH1D( *sf_ );
   (sfH->GetXaxis())->Set( N, binLimits );
   for( Int_t i=0; i<N; i++){
      sfH->SetBinContent( i+1, ( *sf_ )[i] );
   }

   // create canvas
  TCanvas *can5 = new TCanvas( "responseRatios", "responseRatios", 0, 0, 700, 500 );
  SetCanvasStyle( can5 );
  can5->SetLogx();
  TH2F* frameResp = new TH2F( "", "", 500, Emin, Emax, 500, 0.84, 1.10 );
  SetFrameStyle( frameResp );
  frameResp->GetXaxis()->SetMoreLogLabels();
  frameResp->SetXTitle( "p_{T}^{jet} [GeV]" );
  frameResp->SetYTitle( "Response_{Data}/Response_{MC}" );
  myText(0.18,0.9,1,"anti-k_{t} #font[52]{R}=0." + R_ + ", " + EM_LC_ + "+JES",0.05);
  PlotLabelEnergyLumi( 0.74, 0.93 );
  sfH->Draw("same");

  TCanvas *can1 = 0;
  TH2F* frame = new TH2F( "", "", 500, Emin, Emax, 500, -0.01, 0.065 );
  SetFrameStyle( frame, 0 );
  frame->SetXTitle( "p_{T}^{jet} [GeV]" );
  frame->SetYTitle( "Relative uncertainties" );
  frame->GetXaxis()->SetMoreLogLabels();

  TLegend *legend1[3], *legend2[3], *legend3[3];
  Int_t NC = -1;
  TVectorD *systUncertaintyPhotonEscale_ = new TVectorD(N), *systUncertaintyElectronEscale_ = new TVectorD(N);
  for( Int_t i=0; i<N; i++ ){
     ( *systUncertaintyPhotonEscale_ )[i] = 0.;
     ( *systUncertaintyElectronEscale_ )[i] = 0.;
  }
  std::vector<TH1D*> npH_v;
  for( Int_t j=0; j<Nf; j++ ){

     if( j==0 || j==18 || j==37 ){
        // create canvas
        if( j==0  ){ can1 = new TCanvas( "NuisanceParameters_1", "NuisanceParameters_1", 0, 0, 700, 500 ); NC++; }
        if( j==18 ){ can1 = new TCanvas( "NuisanceParameters_2", "NuisanceParameters_2", 0, 0, 700, 500 ); NC++; }
        if( j==37 ){ can1 = new TCanvas( "NuisanceParameters_3", "NuisanceParameters_3", 0, 0, 700, 500 ); NC++; }
        SetCanvasStyle( can1 );
        can1->SetLogx();
        frame->Draw();
        myText(0.18,0.9,1,"anti-k_{t} #font[52]{R}=0." + R_ + ", " + EM_LC_ + "+JES",0.05);
        PlotLabelEnergyLumi( 0.74, 0.93 );

        Float_t deltaY, dyg = 0.10, dxg = 0.24;
        deltaY = 6*0.05;
        legend1[NC] = new TLegend( 1 - 2*dxg - can1->GetRightMargin() -0.08 - 0.25, 1 - can1->GetTopMargin() - deltaY - dyg, 
                                   1 - 2*dxg - can1->GetRightMargin() -0.08 - 0.06, 1 - can1->GetTopMargin() - dyg );
        legend2[NC] = new TLegend( 1 - 1*dxg - can1->GetRightMargin() -0.08 - 0.23, 1 - can1->GetTopMargin() - deltaY - dyg, 
                                   1 - 1*dxg - can1->GetRightMargin() -0.08 - 0.13, 1 - can1->GetTopMargin() - dyg );
        deltaY = 6*0.05;                                                                                                
        legend3[NC] = new TLegend( 1 - 0*dxg - can1->GetRightMargin() -0.08 - 0.32, 1 - can1->GetTopMargin() - deltaY - dyg, 
                                   1 - 0*dxg - can1->GetRightMargin() -0.08 - 0.13, 1 - can1->GetTopMargin() - dyg );

        legend1[NC]->SetFillStyle( 1 );     legend2[NC]->SetFillStyle( 1 );     legend3[NC]->SetFillStyle( 1 );   
        legend1[NC]->SetBorderSize(0);      legend2[NC]->SetBorderSize(0);      legend3[NC]->SetBorderSize(0);    
        legend1[NC]->SetLineColor(0);       legend2[NC]->SetLineColor(0);       legend3[NC]->SetLineColor(0);     
        legend1[NC]->SetMargin( 0.34 );     legend2[NC]->SetMargin( 0.34 );     legend3[NC]->SetMargin( 0.34 );   
        legend1[NC]->SetTextSize( 0.045 );  legend2[NC]->SetTextSize( 0.045 );  legend3[NC]->SetTextSize( 0.045 );
        can1->cd();
        legend1[NC]->Draw( "same" );        legend2[NC]->Draw( "same" );        legend3[NC]->Draw( "same" );      
     }
     Int_t jP = j;
     if( j>= 37 ){ jP -= 37; }
     else{ if( j>= 18 ){ jP -= 18; } }

     TVectorD *np_j_ = new TVectorD(N);

     fj = fopen(filesLocationS+NPfileNames[j],"r");
     if( !fj ){
        cout << "Could not open file: " << NPfileNames[j] << endl;
        exit(1);
     }
     for( Int_t i=0; i<N; i++ ){
        fscanf(fj,"%lf",&r1);
        fscanf(fj,"%lf",&r2);
        fscanf(fj,"%lf",&rij);
        ( *np_j_ )[i] = rij;
     }
     fclose( fj );

     TH1D *NuisanceParamjH = new TH1D( *np_j_ );
     (NuisanceParamjH->GetXaxis())->Set( N, binLimits );
     for( Int_t i=0; i<N; i++){
        NuisanceParamjH->SetBinContent( i+1, ( *np_j_ )[i] );
     }
     NuisanceParamjH->SetLineColor( 1 + jP%5 );
     NuisanceParamjH->SetLineStyle( 1 + jP/5 );
     NuisanceParamjH->SetLineWidth( 2 );

     can1->cd();
     NuisanceParamjH->Draw( "same" );
     npH_v.push_back( NuisanceParamjH );

     if( jP<6 ){
        legend1[NC]->AddEntry( NuisanceParamjH, TString(NPfileNames[j]).ReplaceAll("JESfitResult_NP_","").ReplaceAll("_asymsyst","").ReplaceAll("mpf","").ReplaceAll("gammajet","").ReplaceAll("mjb","").ReplaceAll("zjet","").ReplaceAll("modeling","").ReplaceAll(".txt",""), "L" );
     }
     else{
        if( jP<12 ){
           legend2[NC]->AddEntry( NuisanceParamjH, TString(NPfileNames[j]).ReplaceAll("JESfitResult_NP_","").ReplaceAll("_asymsyst","").ReplaceAll("mpf","").ReplaceAll("gammajet","").ReplaceAll("mjb","").ReplaceAll("zjet","").ReplaceAll("modeling","").ReplaceAll(".txt",""), "L" );
        }
        else{
           legend3[NC]->AddEntry( NuisanceParamjH, TString(NPfileNames[j]).ReplaceAll("JESfitResult_NP_","").ReplaceAll("_asymsyst","").ReplaceAll("mpf","").ReplaceAll("gammajet","").ReplaceAll("mjb","").ReplaceAll("zjet","").ReplaceAll(".txt",""), "L" );
        }
     }

     if( TString(NPfileNames[j]).Contains("photonescale") ){
        cout << "Found photonescale ! " << endl;
        for( Int_t ib=0; ib<N; ib++ ){
           ( *systUncertaintyPhotonEscale_ )[ib] = NuisanceParamjH->GetBinContent(ib+1);
        }
     }
     else{
        if( TString(NPfileNames[j]).Contains("elscale") ){
           cout << "Found elscale ! " << endl;
           for( Int_t ib=0; ib<N; ib++ ){
              ( *systUncertaintyElectronEscale_ )[ib] = NuisanceParamjH->GetBinContent(ib+1);
           }
        }
        else{
           for( Int_t ib=0; ib<N; ib++ ){
              for( Int_t jb=0; jb<N; jb++ ){
                 if( TString(NPfileNames[j]).Contains("stat") ){
                    (*covMatStat_original)[ib][jb] += ( NuisanceParamjH->GetBinContent(ib+1) ) * ( NuisanceParamjH->GetBinContent(jb+1) );
                 }
                 else{
                    (*covMatSyst_original)[ib][jb] += ( NuisanceParamjH->GetBinContent(ib+1) ) * ( NuisanceParamjH->GetBinContent(jb+1) );
                 }
                 (*covMatTot_original)[ib][jb] += ( NuisanceParamjH->GetBinContent(ib+1) ) * ( NuisanceParamjH->GetBinContent(jb+1) );
              }
           }
        }
     }

     if( j==17 ){ can1->Print(filesLocationS + ReducedNP_s + "Plots/NuisanceParameters_TSpline2_" + EM_LCW_ + "JES_R" + R_ + "_1.eps", "eps"); }
     if( j==36 ){ can1->Print(filesLocationS + ReducedNP_s + "Plots/NuisanceParameters_TSpline2_" + EM_LCW_ + "JES_R" + R_ + "_2.eps", "eps"); }
     if( j==54 ){ can1->Print(filesLocationS + ReducedNP_s + "Plots/NuisanceParameters_TSpline2_" + EM_LCW_ + "JES_R" + R_ + "_3.eps", "eps"); }
  }
  if( linearSumEscales ){
     for( Int_t ib=0; ib<N; ib++ ){
        for( Int_t jb=0; jb<N; jb++ ){
           (*covMatSyst_original)[ib][jb] += ((*systUncertaintyPhotonEscale_)[ib]+(*systUncertaintyElectronEscale_)[ib]) * ((*systUncertaintyPhotonEscale_)[jb]+(*systUncertaintyElectronEscale_)[jb]);
           (*covMatTot_original)[ib][jb] += ((*systUncertaintyPhotonEscale_)[ib]+(*systUncertaintyElectronEscale_)[ib]) * ((*systUncertaintyPhotonEscale_)[jb]+(*systUncertaintyElectronEscale_)[jb]);
        }
     }
  }
  else{
     for( Int_t ib=0; ib<N; ib++ ){
        for( Int_t jb=0; jb<N; jb++ ){
           (*covMatSyst_original)[ib][jb] += (*systUncertaintyPhotonEscale_)[ib] * (*systUncertaintyPhotonEscale_)[jb] + (*systUncertaintyElectronEscale_)[ib] * (*systUncertaintyElectronEscale_)[jb];
           (*covMatTot_original)[ib][jb] += (*systUncertaintyPhotonEscale_)[ib] * (*systUncertaintyPhotonEscale_)[jb] + (*systUncertaintyElectronEscale_)[ib] * (*systUncertaintyElectronEscale_)[jb];
        }
     }
  }
  TVectorD *totalUncertaintyOriginal_ = new TVectorD(N), *statUncertaintyOriginal_ = new TVectorD(N);
  for( Int_t ib=0; ib<N; ib++ ){
     ( *statUncertaintyOriginal_ )[ib] = sqrt( (*covMatStat_original)[ib][ib] );
     ( *totalUncertaintyOriginal_ )[ib] = sqrt( (*covMatTot_original)[ib][ib] );
  }

  TH2F* frame2D = new TH2F( "", "", 500, Emin, Emax, 500, Emin, Emax );
  frame2D->SetXTitle( "p_{T}^{jet} [GeV]" );
  frame2D->SetYTitle( "p_{T}^{jet} [GeV]" );
  frame2D->GetXaxis()->SetTitleOffset( 1.26 );
  frame2D->GetYaxis()->SetTitleOffset( 1.26 );
  frame2D->GetXaxis()->SetMoreLogLabels();
  //  frame2D->GetYaxis()->SetMoreLogLabels();



  TMatrixD *significanceMatrix = 0, *significanceMatrixLD = 0;
  //  TH1D *maxDistLowH, *maxDistHighH = 0;
  EvaluateSignificance( sfH, covMatTot_original, significanceMatrix, 0.003, significanceMatrixLD  /*1., maxDistLowH, maxDistHighH*/ );
  TH2D *significanceMatrixH = new TH2D( *significanceMatrix );
  TH2D *significanceMatrixLDH = new TH2D( *significanceMatrixLD );
  (significanceMatrixH->GetXaxis())->Set( N, binLimits );
  (significanceMatrixH->GetYaxis())->Set( N, binLimits );
  (significanceMatrixLDH->GetXaxis())->Set( N, binLimits );
  (significanceMatrixLDH->GetYaxis())->Set( N, binLimits );

  TCanvas *canSM = new TCanvas( "Original Significance Matrix", "Original Significance Matrix", 0, 0, 700, 500 );
  SetCanvasStyle2D( canSM );
  frame2D->Draw();
  significanceMatrixH->Draw("colzsame");
  //  maxDistLowH->Draw("same");
  //  maxDistHighH->SetLineStyle(2);
  //  maxDistHighH->Draw("same");
  //  canSM->SetLogz();
  //  canSM->Print(filesLocationS + ReducedNP_s + "Plots/significanceMatrix_TSpline2_" + EM_LCW_ + "JES_R" + R_ + ".eps", "eps");
  canSM->Print(filesLocationS + ReducedNP_s + "Plots/significanceMatrix_TSpline2_" + EM_LCW_ + "JES_R" + R_ + ".png", "png");

  TCanvas *canSM_LD = new TCanvas( "Original Significance Matrix LD", "Original Significance Matrix LD", 0, 0, 700, 500 );
  SetCanvasStyle2D( canSM_LD );
  frame2D->Draw();
  significanceMatrixLDH->Draw("colzsame");
  //  canSM_LD->Print(filesLocationS + ReducedNP_s + "Plots/significanceMatrix_TSpline2_" + EM_LCW_ + "JES_R" + R_ + "_LD.eps", "eps");
  canSM_LD->Print(filesLocationS + ReducedNP_s + "Plots/significanceMatrix_TSpline2_" + EM_LCW_ + "JES_R" + R_ + "_LD.png", "png");



  TGraph *band = new TGraph(2*N+2), *bandStat = new TGraph(2*N+2);
  for (Int_t ibin=1; ibin<=N; ibin++) {
     band->SetPoint( ibin,   sfH->GetBinCenter( ibin ),      sfH->GetBinContent( ibin ) + ( *totalUncertaintyOriginal_ )[ibin-1] );
     band->SetPoint( N+ibin, sfH->GetBinCenter( N-ibin+1  ), sfH->GetBinContent( N-ibin+1 ) - ( *totalUncertaintyOriginal_ )[N-ibin] );
     bandStat->SetPoint( ibin,   sfH->GetBinCenter( ibin ),      sfH->GetBinContent( ibin ) + ( *statUncertaintyOriginal_ )[ibin-1] );
     bandStat->SetPoint( N+ibin, sfH->GetBinCenter( N-ibin+1  ), sfH->GetBinContent( N-ibin+1 ) - ( *statUncertaintyOriginal_ )[N-ibin] );
  }
  Double_t mGx = 0., mGy = 0.;

  band->GetPoint( 1, mGx, mGy );
  band->SetPoint( 0, 17., mGy );
  band->GetPoint( 2*N, mGx, mGy );
  band->SetPoint( 2*N+1, 17., mGy );
  bandStat->GetPoint( 1, mGx, mGy );
  bandStat->SetPoint( 0, 17., mGy );
  bandStat->GetPoint( 2*N, mGx, mGy );
  bandStat->SetPoint( 2*N+1, 17., mGy );

  Int_t ci = TColor::GetColor("#aaFF33");
  band->SetFillColor( ci );
  bandStat->SetFillColor( 4 );

  TCanvas *can6 = new TCanvas( "responseRatioOriginal", "responseRatioOriginal", 0, 0, 700, 500 );
  SetCanvasStyle( can6 );
  can6->SetLogx();
  frameResp->Draw();
  myText(0.18,0.9,1,"anti-k_{t} #font[52]{R}=0." + R_ + ", " + EM_LC_ + "+JES",0.05);
  PlotLabelEnergyLumi( 0.74, 0.93 );
  //  sfH->Draw("same");
  band->Draw("F");
  bandStat->Draw("Fsame");
  sfH->Draw("same");

   // checks if file with name "fin" is already open, and if not opens one
   TFile* file = OpenFile( fin );  
   cout << "--- Plotting channel \"" << channelName << "\"" << endl;
   // check if exists
   TDirectory* channelDir = (TDirectory*)file->Get( channelName );
   if (!channelDir) {
      cout << "*** Could not locate directory: \"" << channelName << "\"" 
           << " in ROOT file \"" << fin << "\"" << endl;
      return;
   }
   TString channelTitle     = channelDir->GetTitle();
   // move to directory
   channelDir->cd();
   // get all measurement graphs 
   TList measurements;
   UInt_t ninst = GetListOfKeys( channelDir, "TGraph", measurements );
   if (ninst == 0) {
      cout << "*** Could not find any TGraph keys in directory: \"" << channelDir->GetName() << "\"" << endl;
      return;
   }
   // search for the right  in full list of keys
   TIter   nextKey( &measurements );
   TKey*   key;
   TGraph* graph;  // = (TGraph*)measurements.First();
   TList graphs;
   while ((key = (TKey*)nextKey())) {
      graph = (TGraph*)key->ReadObj();
      TString name = graph->GetName();      

      if ( !name.Contains( "Merged" ) && !name.Contains( "Chi2Plot" ) && !name.Contains( "FF" ) 
           && (!(graph->GetXaxis()->GetXmin() > Emax || graph->GetXaxis()->GetXmax() < Emin )) ){
         for( Int_t ibin=0; ibin<graph->GetN(); ibin++ ){
            ((TGraphErrors*)graph)->SetPointError( ibin, 0., graph->GetErrorY(ibin) );
         }
         graphs.Add( graph );
      }
   }

   // Draw legend
   Float_t deltaY_ = 0.3, dyg_ = 0.48 /*0.03*/, dxg_ = 0.4 /*0.02*/, y3_ = 0.20;
   TLegend *legend1_ = new TLegend( 1 - dxg_ - can6->GetRightMargin() /*-0.875*/ - 0.25, 1 - can6->GetTopMargin() - deltaY_ - dyg_,
                                    1 - dxg_ - can6->GetRightMargin() /*-0.675*/ - 0.05, 1 - can6->GetTopMargin() - dyg_);
   TLegend *legend2_ = new TLegend( 1 - dxg_ - can6->GetRightMargin() /*-0.875*/ - 0.19, 1 - can6->GetTopMargin() - deltaY_ - dyg_,
                                    1 - dxg_ - can6->GetRightMargin() /*-0.675*/, 1 - can6->GetTopMargin() - dyg_);
   TLegend *legend3_ = new TLegend( 1 - dxg_ - can6->GetRightMargin() /*-0.875*/ -0.25 , 1 - can6->GetTopMargin() - deltaY_ - dyg_ - y3_,
                                    1 - dxg_ - can6->GetRightMargin() /*-0.675*/ -0.04 - 0.05, 1 - can6->GetTopMargin() - dyg_ - y3_);
   legend1_->SetFillStyle( 1 );    legend2_->SetFillStyle( 1 );   legend3_->SetFillStyle( 1 );
   legend1_->SetBorderSize(0);     legend2_->SetBorderSize(0);    legend3_->SetBorderSize(0);
   legend1_->SetLineColor(0);      legend2_->SetLineColor(0);     legend3_->SetLineColor(0);
   legend1_->SetMargin( 0.25 );    legend2_->SetMargin( 0.25 );   legend3_->SetMargin( 0.25 );
   can6->cd();
   legend1_->Draw( "same" );       legend2_->Draw( "same" );      legend3_->Draw( "same" );
   legend1_->SetTextSize( 0.05 );  legend2_->SetTextSize( 0.05 ); legend3_->SetTextSize( 0.05 );

   TLegend *legendNC = legend1_;
   // loop over graphs and plot them
   Int_t nlegend_ = 0, nlegend1_ = 3;
   TList exps;
   TIter nextGraph( &graphs );
   while ((graph = (TGraph*)nextGraph())) {
      cout << "--- ... drawing graph: " << graph->GetName() << " with " << graph->GetN() << " Points  [ " << graph->GetXaxis()->GetXmin() << " ; " << graph->GetXaxis()->GetXmax() << " ] " << endl;
      if (!SetGraphStyle( graph )) {
         cout << "*** Experiment: \"" << graph->GetName() << "\" not found in \"SetGraphStyle\"" << endl;
         return;
      }

      can6->cd();
      graph->Draw( "P" );

      // only draw a single legend entry per experiment
      TObjString *str = new TObjString( graph->GetName() );
      TString *strLegend = new TString( graph->GetName() );
      if( (TString(graph->GetName())).Contains( "MJB" ) ){
         str = new TObjString("Multi-jet");
         strLegend = new TString("Multi-jet");
      }
      if( (TString(graph->GetName())).Contains( "ZjetNP1" ) ){
         str = new TObjString("Z-jet");
         strLegend = new TString("Z-jet");
      }
      if( (TString(graph->GetName())).Contains( "gamma-jet" ) ){
         str = new TObjString("#gamma-jet");
         strLegend = new TString("#gamma-jet");
      }
      if (!exps.FindObject(str->GetName()) && (!(TString(graph->GetName())).Contains( "ZjetNP2" )) ){
         legendNC->AddEntry( graph, strLegend->ReplaceAll("_Xsec",""), "P" );
         exps.Add( str );
         nlegend_++;
         if( nlegend_ >= nlegend1_ ){
            legendNC = legend2_;
         }
      }
   }

   legend3_->AddEntry( band, "Total uncertainty","fl" );
   legend3_->AddEntry( bandStat, "Statistical component","fl" );

   Double_t deltaY1_ = nlegend1_*0.06 /*+ 0.015*/, deltaY2_ = (nlegend_-nlegend1_ )*0.06 /*+ 0.01*//*+ 0.015*/;
   cout << " nlegend_ = " << nlegend_ << " " << nlegend1_ << endl;
   legend1_->SetY1(  1 - can6->GetTopMargin() - deltaY1_ - dyg_);
   legend2_->SetY1(  1 - can6->GetTopMargin() - deltaY2_ - dyg_);
   legend3_->SetY1(  1 - can6->GetTopMargin() - y3_ - dyg_ - 2.*0.06 );
   
   // redraw axes
   can6->cd();
   frameResp->Draw("sameaxis");
         
   // save canvas to file
   can6->Update();
   can6->Print(filesLocationS + ReducedNP_s + "Plots/responseRatioOriginal_TSpline2_" + EM_LC_ + "JES_R" + R_ + ".eps", "eps");


   // read covariance matrix from toys
   TMatrixD *covMatToys_ = new TMatrixD(N,N);
   FILE *fCM = fopen(filesLocationS+"JESfitResult_CovMat.txt","r");
   if( !fCM ){
      cout << "Could not open file: " << "JESfitResult_CovMat.txt" << endl;
      exit(1);
   }
   for( Int_t i=0; i<N; i++ ){
      for( Int_t j=0; j<N; j++ ){
         fscanf(fCM,"%lf",&r1);
         (*covMatToys_)[i][j] = r1;
      }
   }
   fclose( fCM );

   TH2D *covMatStat_originalH = 0, *covMatSyst_originalH = 0, *covMatTot_originalH = 0, *covMatToys_H = 0;
  TString *covS_ = 0, *sourceCov_ = 0;
  if( plotCorrelations ){
     covS_ = new TString( "corr" );
     covMatStat_originalH = new TH2D(* ComputeCorrelation( covMatStat_original, N ) );
     covMatSyst_originalH = new TH2D(* ComputeCorrelation( covMatSyst_original, N ) );
     covMatTot_originalH = new TH2D(* ComputeCorrelation( covMatTot_original, N ) );
     covMatToys_H = new TH2D(* ComputeCorrelation( covMatToys_, N ) );
  }
  else{
     covS_ = new TString( "cov" );
     covMatStat_originalH = new TH2D(*covMatStat_original);
     covMatSyst_originalH = new TH2D(*covMatSyst_original);
     covMatTot_originalH = new TH2D(*covMatTot_original);
     covMatToys_H = new TH2D(*covMatToys_);
  }
  sourceCov_ = new TString("NuisanceParameters_");

  (covMatStat_originalH->GetXaxis())->Set( N, binLimits );
  (covMatStat_originalH->GetYaxis())->Set( N, binLimits );
  (covMatSyst_originalH->GetXaxis())->Set( N, binLimits );
  (covMatSyst_originalH->GetYaxis())->Set( N, binLimits );
  (covMatTot_originalH->GetXaxis())->Set( N, binLimits );
  (covMatTot_originalH->GetYaxis())->Set( N, binLimits );
  (covMatToys_H->GetXaxis())->Set( N, binLimits );
  (covMatToys_H->GetYaxis())->Set( N, binLimits );
  covMatStat_originalH->SetMinimum( -1. );
  covMatSyst_originalH->SetMinimum( -1. );
  covMatTot_originalH->SetMinimum( -1. );
  covMatToys_H->SetMinimum( -1. );

  TCanvas *can2_original = new TCanvas( (*covS_)+"MatStat_original", (*covS_)+"MatStat_original", 0, 0, 700, 500 );
  SetCanvasStyle2D( can2_original );
  frame2D->Draw();
  covMatStat_originalH->Draw("colzsame");
  //  can2_original->Print(filesLocationS + ReducedNP_s + "Plots/" + (*sourceCov_) +(*covS_)+"MatStat_original_TSpline2_" + EM_LCW_ + "JES_R" + R_ + ".eps", "eps");
  can2_original->Print(filesLocationS + ReducedNP_s + "Plots/" + (*sourceCov_) +(*covS_)+"MatStat_original_TSpline2_" + EM_LCW_ + "JES_R" + R_ + ".png", "png");

  TCanvas *can3_original = new TCanvas( (*covS_)+"MatSyst_original", (*covS_)+"MatSyst_original", 0, 0, 700, 500 );
  SetCanvasStyle2D( can3_original );
  frame2D->Draw();
  covMatSyst_originalH->Draw("colzsame");
  //  can3_original->Print(filesLocationS + ReducedNP_s + "Plots/" + (*sourceCov_) +(*covS_)+"MatSyst_original_TSpline2_" + EM_LCW_ + "JES_R" + R_ + ".eps", "eps");
  can3_original->Print(filesLocationS + ReducedNP_s + "Plots/" + (*sourceCov_) +(*covS_)+"MatSyst_original_TSpline2_" + EM_LCW_ + "JES_R" + R_ + ".png", "png");

  TCanvas *can4_original = new TCanvas( (*covS_)+"MatTot_original", (*covS_)+"MatTot_original", 0, 0, 700, 500 );
  SetCanvasStyle2D( can4_original );
  frame2D->Draw();
  covMatTot_originalH->Draw("colzsame");
  //  can4_original->Print(filesLocationS + ReducedNP_s + "Plots/" + (*sourceCov_) +(*covS_)+"MatTot_original_TSpline2_" + EM_LCW_ + "JES_R" + R_ + ".eps", "eps");
  can4_original->Print(filesLocationS + ReducedNP_s + "Plots/" + (*sourceCov_) +(*covS_)+"MatTot_original_TSpline2_" + EM_LCW_ + "JES_R" + R_ + ".png", "png");

  TMatrixD *dMatTot_, *sMatTot_;
  TVectorD *eigenVal_;
  Compute_desMatrices_covMat( dMatTot_, eigenVal_, sMatTot_, *covMatTot_original );

  TH1D *eigenH = new TH1D( *eigenVal_ );
  for( Int_t i=0; i<N; i++){
     //     eigenH->SetBinContent( i+1, ( *dMatTot_ )[i][i] );
     eigenH->SetBinContent( i+1, ( *eigenVal_ )[i] );
  }

  TCanvas *can7 = new TCanvas( "eigen values", "eigen values", 0, 0, 700, 500 );
  SetCanvasStyle( can7 );
  can7->SetLogy();
  TH2F* frameEigen = new TH2F( "", "", 500, 0, N, 500, 1.e-8, 1. );
  SetFrameStyle( frameEigen );
  frameEigen->GetXaxis()->SetMoreLogLabels();
  frameEigen->GetXaxis()->SetRangeUser( 0, 40 );
  frameEigen->SetXTitle( "i" );
  frameEigen->SetYTitle( "eigen values" );
  myText(0.18,0.9,1,"anti-k_{t} #font[52]{R}=0." + R_ + ", " + EM_LC_ + "+JES",0.05);
  PlotLabelEnergyLumi( 0.74, 0.93 );
  eigenH->Draw("same");
  can7->Print(filesLocationS + ReducedNP_s + "Plots/eigenValues_TSpline2_" + EM_LC_ + "JES_R" + R_ + ".eps", "eps");


  TCanvas *can8 = new TCanvas( "used eigen vectors", "used eigen vectors", 0, 0, 700, 500 );
  SetCanvasStyle( can8 );
  can8->SetLogx();
  TH2F* frameEigenV = new TH2F( "", "", 500, Emin, Emax, 500, -0.4, 0.4 );
  SetFrameStyle( frameEigenV );
  frameEigenV->GetXaxis()->SetMoreLogLabels();
  frameEigenV->SetXTitle( "p_{T}^{jet} [GeV]" );
  frameEigenV->SetYTitle( "e v" );
  myText(0.18,0.9,1,"anti-k_{t} #font[52]{R}=0." + R_ + ", " + EM_LC_ + "+JES",0.05);
  PlotLabelEnergyLumi( 0.74, 0.93 );

  TCanvas *can9 = new TCanvas( "Normalized used eigen vectors", "Normalized used eigen vectors", 0, 0, 700, 500 );
  SetCanvasStyle( can9 );
  can9->SetLogx();
  TH2F* frameEigenVn = new TH2F( "", "", 500, Emin, Emax, 500, -0.04, 0.04 );
  SetFrameStyle( frameEigenVn );
  frameEigenVn->GetXaxis()->SetMoreLogLabels();
  frameEigenVn->SetXTitle( "p_{T}^{jet} [GeV]" );
  frameEigenVn->SetYTitle( "e v" );
  myText(0.18,0.9,1,"anti-k_{t} #font[52]{R}=0." + R_ + ", " + EM_LC_ + "+JES",0.05);
  PlotLabelEnergyLumi( 0.74, 0.93 );

  TMatrixD *covMatTot_normalizedEigenVec1 = new TMatrixD( N, N ), *covMatTot_normalizedEigenVec2 = new TMatrixD( N, N ), *covMatTot_normalizedEigenVecNOlastNP_diff = new TMatrixD( N, N );
  for( Int_t ib=0; ib<N; ib++ ){
     for( Int_t jb=0; jb<N; jb++ ){
        (*covMatTot_normalizedEigenVec1)[ib][jb] = 0.;
        (*covMatTot_normalizedEigenVec2)[ib][jb] = 0.;
     }
  }

  std::vector<TH1D*> usedEigenVectors_v;
  for( Int_t c=0; c<usedEigenVectors; c++){
     TH1D *eigenVecH = new TH1D( *eigenVal_ ), *normalizedEigenVecH = new TH1D( *eigenVal_ );
     for( Int_t i=0; i<N; i++){
        eigenVecH->SetBinContent( i+1, ( *sMatTot_ )[i][c] );
        normalizedEigenVecH->SetBinContent( i+1, ( *sMatTot_ )[i][c] * sqrt( (*eigenVal_)[c] ) );
     }
     (eigenVecH->GetXaxis())->Set( N, binLimits );
     (normalizedEigenVecH->GetXaxis())->Set( N, binLimits );
     usedEigenVectors_v.push_back( normalizedEigenVecH );
     eigenVecH->SetLineColor( (c+1<10) ? c+1 : c+2 );
     normalizedEigenVecH->SetLineColor( (c+1<10) ? c+1 : c+2 );
     can8->cd();
     eigenVecH->Draw("same");
     can9->cd();
     normalizedEigenVecH->Draw("same");

     for( Int_t ib=0; ib<N; ib++ ){
        for( Int_t jb=0; jb<N; jb++ ){
           (*covMatTot_normalizedEigenVec1)[ib][jb] += ( normalizedEigenVecH->GetBinContent(ib+1) ) * ( normalizedEigenVecH->GetBinContent(jb+1) );
        }
     }
     stringstream sNP;
     sNP << c;
     TString NPS;
     sNP >> NPS;
     SaveNPtoFile( N, normalizedEigenVecH, new TString(filesLocationS + ReducedNP_s + "NP_"+NPS+".txt") );

     if( c == usedEigenVectors-1 ){
        TH1D* normalizedEigenVecHleft = new TH1D( *eigenVal_ );
        for( Int_t i=0; i<N; i++){
           if( (*covMatTot_original)[i][i] >= (*covMatTot_normalizedEigenVec1)[i][i] ){
              normalizedEigenVecHleft->SetBinContent( i+1, sqrt( (*covMatTot_original)[i][i] - (*covMatTot_normalizedEigenVec1)[i][i] ) );

              Double_t posSumLeft = 0., negSumLeft = 0.;
              for( Int_t cl=usedEigenVectors; cl<N; cl++){
                 if( (*sMatTot_)[i][cl] > 0 ){
                    posSumLeft += pow( (*sMatTot_)[i][cl], 2) * (*eigenVal_)[cl];
                 }
                 else{
                    negSumLeft += pow( (*sMatTot_)[i][cl], 2) * (*eigenVal_)[cl];
                 }
              }
              if( fabs( (*covMatTot_original)[i][i] - (*covMatTot_normalizedEigenVec1)[i][i] - posSumLeft - negSumLeft ) > 1.e-10 ){
                 cout << "Potential problem in sum of n.p.! " << i << " " << (*covMatTot_original)[i][i] - (*covMatTot_normalizedEigenVec1)[i][i] - posSumLeft - negSumLeft << endl;
              }
           }
           else{
              cout << "Warning: diagonal element larger than in the original matrix -> " << i << " " << (*covMatTot_original)[i][i] << " " << (*covMatTot_normalizedEigenVec1)[i][i] << endl;
              normalizedEigenVecHleft->SetBinContent( i+1, 0. );
           }
        }
        (normalizedEigenVecHleft->GetXaxis())->Set( N, binLimits );
        normalizedEigenVecHleft->SetLineColor( (usedEigenVectors+1<10) ? usedEigenVectors+1 : usedEigenVectors+2 );
        can9->cd();
        normalizedEigenVecHleft->Draw("same");

        stringstream sNP_;
        sNP_ << c+1;
        TString NPS_;
        sNP_ >> NPS_;
        SaveNPtoFile( N, normalizedEigenVecHleft, new TString(filesLocationS + ReducedNP_s + "NP_"+NPS_+"_left.txt") );

        for( Int_t ib=0; ib<N; ib++ ){
           for( Int_t jb=0; jb<N; jb++ ){
              (*covMatTot_normalizedEigenVecNOlastNP_diff)[ib][jb] = (*covMatTot_original)[ib][jb] - (*covMatTot_normalizedEigenVec1)[ib][jb];
              (*covMatTot_normalizedEigenVec2)[ib][jb] = (*covMatTot_normalizedEigenVec1)[ib][jb];
              if( ib == jb ){
                 (*covMatTot_normalizedEigenVec2)[ib][jb] += ( normalizedEigenVecHleft->GetBinContent(ib+1) ) * ( normalizedEigenVecHleft->GetBinContent(jb+1) );
              }
              (*covMatTot_normalizedEigenVec1)[ib][jb] += ( normalizedEigenVecHleft->GetBinContent(ib+1) ) * ( normalizedEigenVecHleft->GetBinContent(jb+1) );
           }
        }
     }
  }

  can8->Print(filesLocationS + ReducedNP_s + "Plots/usedEigenVectors_TSpline2_" + EM_LC_ + "JES_R" + R_ + ".eps", "eps");
  can9->Print(filesLocationS + ReducedNP_s + "Plots/usedNormalizedEigenVectors_TSpline2_" + EM_LC_ + "JES_R" + R_ + ".eps", "eps");
  frameEigenVn->GetYaxis()->SetRangeUser( -0.01, 0.01 );
  can9->Print(filesLocationS + ReducedNP_s + "Plots/usedNormalizedEigenVectors_TSpline2_" + EM_LC_ + "JES_R" + R_ + "_zoom1.eps", "eps");
  frameEigenVn->GetYaxis()->SetRangeUser( -0.005, 0.005 );
  can9->Print(filesLocationS + ReducedNP_s + "Plots/usedNormalizedEigenVectors_TSpline2_" + EM_LC_ + "JES_R" + R_ + "_zoom2.eps", "eps");
  frameEigenVn->GetYaxis()->SetRangeUser( -0.04, 0.04 );


  TH2D *covMatTot_normalizedEigenVec1H = 0, *covMatTot_normalizedEigenVec2H = 0, *covMatTot_normalizedEigenVecNOlastNP_diffH = 0;
  if( plotCorrelations ){
     covMatTot_normalizedEigenVec1H = new TH2D(* ComputeCorrelation( covMatTot_normalizedEigenVec1, N ) );
     covMatTot_normalizedEigenVec2H = new TH2D(* ComputeCorrelation( covMatTot_normalizedEigenVec2, N ) );
     covMatTot_normalizedEigenVecNOlastNP_diffH = new TH2D(* ComputeCorrelation( covMatTot_normalizedEigenVecNOlastNP_diff, N ) );
  }
  else{
     covMatTot_normalizedEigenVec1H = new TH2D(*covMatTot_normalizedEigenVec1);
     covMatTot_normalizedEigenVec2H = new TH2D(*covMatTot_normalizedEigenVec2);
     covMatTot_normalizedEigenVecNOlastNP_diffH = new TH2D(*covMatTot_normalizedEigenVecNOlastNP_diff);
  }
  (covMatTot_normalizedEigenVec1H->GetXaxis())->Set( N, binLimits );  (covMatTot_normalizedEigenVec2H->GetXaxis())->Set( N, binLimits );  (covMatTot_normalizedEigenVecNOlastNP_diffH->GetXaxis())->Set( N, binLimits );
  (covMatTot_normalizedEigenVec1H->GetYaxis())->Set( N, binLimits );  (covMatTot_normalizedEigenVec2H->GetYaxis())->Set( N, binLimits );  (covMatTot_normalizedEigenVecNOlastNP_diffH->GetYaxis())->Set( N, binLimits );
  covMatTot_normalizedEigenVec1H->SetMinimum( -1. );  covMatTot_normalizedEigenVec2H->SetMinimum( -1. );  covMatTot_normalizedEigenVecNOlastNP_diffH->SetMinimum( -1. );
  TCanvas *can4_normalizedEigenVec1 = new TCanvas( (*covS_)+"MatTot_normalizedEigenVec_lastNPcorrelated", (*covS_)+"MatTot_normalizedEigenVec_lastNPcorrelated", 0, 0, 700, 500 );
  SetCanvasStyle2D( can4_normalizedEigenVec1 );
  frame2D->Draw();
  covMatTot_normalizedEigenVec1H->Draw("colzsame");
  //  can4_normalizedEigenVec1->Print(filesLocationS + ReducedNP_s + "Plots/" + (*sourceCov_) +(*covS_)+"MatTot_normalizedEigenVec_TSpline2_" + EM_LCW_ + "JES_R" + R_ + "_lastNPcorrelated.eps", "eps");
  can4_normalizedEigenVec1->Print(filesLocationS + ReducedNP_s + "Plots/" + (*sourceCov_) +(*covS_)+"MatTot_normalizedEigenVec_TSpline2_" + EM_LCW_ + "JES_R" + R_ + "_lastNPcorrelated.png", "png");

  TCanvas *can4_normalizedEigenVec2 = new TCanvas( (*covS_)+"MatTot_normalizedEigenVec_lastNPuncorrelated", (*covS_)+"MatTot_normalizedEigenVec_lastNPuncorrelated", 0, 0, 700, 500 );
  SetCanvasStyle2D( can4_normalizedEigenVec2 );
  frame2D->Draw();
  covMatTot_normalizedEigenVec2H->Draw("colzsame");
  //  can4_normalizedEigenVec2->Print(filesLocationS + ReducedNP_s + "Plots/" + (*sourceCov_) +(*covS_)+"MatTot_normalizedEigenVec_TSpline2_" + EM_LCW_ + "JES_R" + R_ + "_lastNPuncorrelated.eps", "eps");
  can4_normalizedEigenVec2->Print(filesLocationS + ReducedNP_s + "Plots/" + (*sourceCov_) +(*covS_)+"MatTot_normalizedEigenVec_TSpline2_" + EM_LCW_ + "JES_R" + R_ + "_lastNPuncorrelated.png", "png");

  TH2D *covMatTot_normalizedEigenVec1_diffH = new TH2D(*covMatTot_normalizedEigenVec1H), *covMatTot_normalizedEigenVec2_diffH = new TH2D(*covMatTot_normalizedEigenVec2H);
  Double_t maxDiff1 = 0., maxDiff2 = 0.;
  for( Int_t ib=0; ib<N; ib++ ){
     for( Int_t jb=0; jb<N; jb++ ){
        covMatTot_normalizedEigenVec1_diffH->SetBinContent( ib+1, jb+1, covMatTot_normalizedEigenVec1H->GetBinContent(ib+1,jb+1) - covMatTot_originalH->GetBinContent(ib+1,jb+1) );
        covMatTot_normalizedEigenVec2_diffH->SetBinContent( ib+1, jb+1, covMatTot_normalizedEigenVec2H->GetBinContent(ib+1,jb+1) - covMatTot_originalH->GetBinContent(ib+1,jb+1) );
        if( fabs(covMatTot_normalizedEigenVec1_diffH->GetBinContent( ib+1, jb+1 )) > maxDiff1 ){ maxDiff1 = fabs(covMatTot_normalizedEigenVec1_diffH->GetBinContent( ib+1, jb+1 )); }
        if( fabs(covMatTot_normalizedEigenVec2_diffH->GetBinContent( ib+1, jb+1 )) > maxDiff2 ){ maxDiff2 = fabs(covMatTot_normalizedEigenVec2_diffH->GetBinContent( ib+1, jb+1 )); cout << "Max Search: " << ib << " " << jb << "  " << maxDiff2 << "  " << covMatTot_normalizedEigenVec2_diffH->GetXaxis()->GetBinCenter(ib+1) << "  " << covMatTot_normalizedEigenVec2_diffH->GetXaxis()->GetBinCenter(jb+1) << endl; }
     }
  }
  cout << "Maximum difference between matrices: (last NP correlated: " << maxDiff1 << " ) ( last NP uncorrelated: " << maxDiff2 << " )"<< endl;
  covMatTot_normalizedEigenVec1_diffH->SetMinimum( -0.2 );
  covMatTot_normalizedEigenVec2_diffH->SetMinimum( -0.2 );
  covMatTot_normalizedEigenVec1_diffH->SetMaximum(  0.2 );
  covMatTot_normalizedEigenVec2_diffH->SetMaximum(  0.2 );
  TCanvas *can4_normalizedEigenVec1_diff = new TCanvas( (*covS_)+"MatTot_normalizedEigenVec_diff_lastNPcorrelated", (*covS_)+"MatTot_normalizedEigenVec_diff_lastNPcorrelated", 0, 0, 700, 500 );
  SetCanvasStyle2D( can4_normalizedEigenVec1_diff );
  frame2D->Draw();
  covMatTot_normalizedEigenVec1_diffH->Draw("colzsame");
  //  can4_normalizedEigenVec1_diff->Print(filesLocationS + ReducedNP_s + "Plots/" + (*sourceCov_) +(*covS_)+"MatTot_normalizedEigenVec_diff_TSpline2_" + EM_LCW_ + "JES_R" + R_ + "_lastNPcorrelated.eps", "eps");
  can4_normalizedEigenVec1_diff->Print(filesLocationS + ReducedNP_s + "Plots/" + (*sourceCov_) +(*covS_)+"MatTot_normalizedEigenVec_diff_TSpline2_" + EM_LCW_ + "JES_R" + R_ + "_lastNPcorrelated.png", "png");

  TCanvas *can4_normalizedEigenVec2_diff = new TCanvas( (*covS_)+"MatTot_normalizedEigenVec_diff_lastNPuncorrelated", (*covS_)+"MatTot_normalizedEigenVec_diff_lastNPuncorrelated", 0, 0, 700, 500 );
  SetCanvasStyle2D( can4_normalizedEigenVec2_diff );
  frame2D->Draw();
  covMatTot_normalizedEigenVec2_diffH->Draw("colzsame");
  //  can4_normalizedEigenVec2_diff->Print(filesLocationS + ReducedNP_s + "Plots/" + (*sourceCov_) +(*covS_)+"MatTot_normalizedEigenVec_diff_TSpline2_" + EM_LCW_ + "JES_R" + R_ + "_lastNPuncorrelated.eps", "eps");
  can4_normalizedEigenVec2_diff->Print(filesLocationS + ReducedNP_s + "Plots/" + (*sourceCov_) +(*covS_)+"MatTot_normalizedEigenVec_diff_TSpline2_" + EM_LCW_ + "JES_R" + R_ + "_lastNPuncorrelated.png", "png");

  TCanvas *can4_normalizedEigenVecNOlastNP_diff = new TCanvas( (*covS_)+"MatTot_normalizedEigenVec_diff_NOlastNP", (*covS_)+"MatTot_normalizedEigenVec_diff_NOlastNP", 0, 0, 700, 500 );
  SetCanvasStyle2D( can4_normalizedEigenVecNOlastNP_diff );
  frame2D->Draw();
  covMatTot_normalizedEigenVecNOlastNP_diffH->Draw("colzsame");
  //  can4_normalizedEigenVecNOlastNP_diff->Print(filesLocationS + ReducedNP_s + "Plots/" + (*sourceCov_) +(*covS_)+"MatTot_normalizedEigenVec_diff_TSpline2_" + EM_LCW_ + "JES_R" + R_ + "_NOlastNP.eps", "eps");
  can4_normalizedEigenVecNOlastNP_diff->Print(filesLocationS + ReducedNP_s + "Plots/" + (*sourceCov_) +(*covS_)+"MatTot_normalizedEigenVec_diff_TSpline2_" + EM_LCW_ + "JES_R" + R_ + "_NOlastNP.png", "png");


  TCanvas *canCovMatToys = new TCanvas( (*covS_)+"MatTot_toys", (*covS_)+"MatTot_toys", 0, 0, 700, 500 );
  SetCanvasStyle2D( canCovMatToys );
  frame2D->Draw();
  covMatToys_H->Draw("colzsame");
  //  canCovMatToys->Print(filesLocationS + ReducedNP_s + "Plots/" + (*sourceCov_) +(*covS_)+"MatTot_toys_TSpline2_" + EM_LCW_ + "JES_R" + R_ + ".eps", "eps");
  canCovMatToys->Print(filesLocationS + ReducedNP_s + "Plots/" + (*sourceCov_) +(*covS_)+"MatTot_toys_TSpline2_" + EM_LCW_ + "JES_R" + R_ + ".png", "png");

  TCanvas *canTotUncCompare = new TCanvas( "Total Uncertainty Compare reducedNP/toys", "Total Uncertainty Compare reducedNP/toys", 0, 0, 700, 500 );
  SetCanvasStyle( canTotUncCompare );
  canTotUncCompare->SetLogx();
  TH1D *TotUncCompareH = new TH1D( *eigenVal_ );
  (TotUncCompareH->GetXaxis())->Set( N, binLimits );
  for( Int_t i=0; i<N; i++){
     if( (*covMatToys_)[i][i] != 0. ){
        TotUncCompareH->SetBinContent( i+1, ( sqrt(( *covMatTot_normalizedEigenVec1 /*covMatTot_original*/ )[i][i]) - sqrt((*covMatToys_)[i][i]) )/ sqrt((*covMatToys_)[i][i]) );
     }
  }
  SetFrameStyle( TotUncCompareH );
  TotUncCompareH->GetYaxis()->SetRangeUser( -0.1, 0.3 );
  TotUncCompareH->GetXaxis()->SetMoreLogLabels();
  TotUncCompareH->SetXTitle( "p_{T}^{jet} [GeV]" );
  TotUncCompareH->SetYTitle( "Rel Error (NP / Toys - 1)" );
  myText(0.18,0.9,1,"anti-k_{t} #font[52]{R}=0." + R_ + ", " + EM_LC_ + "+JES",0.05);
  PlotLabelEnergyLumi( 0.74, 0.93 );
  canTotUncCompare->Print(filesLocationS + ReducedNP_s + "Plots/TotUncCompare_TSpline2_" + EM_LC_ + "JES_R" + R_ + ".eps", "eps");


}
